#ifndef COMPILER_H
#define COMPILER_H

#include "lexer.h"

typedef enum {
    TOKEN_IDENTIFIER = 'I',
    TOKEN_STRING = 'S',
    TOKEN_NUMBER = 'N',
    TOKEN_TYPEIDENTIFIER = 'T',
    TOKEN_WHITESPACE = 'W',
    TOKEN_OPAREN = '(',
    TOKEN_CPAREN = ')',
    TOKEN_OBRACE = '{',
    TOKEN_CBRACE = '}',
    TOKEN_SEMICOLON = ';',
    TOKEN_COMMA = ','
} TokenType;

#include <stc/ccommon.h>
#include <stc/cstr.h>

#define i_key_str
#define i_val_str
#include <stc/cmap.h>

#define i_type Tokens
#define i_val Token
#define i_opt c_no_cmp
#include <stc/cvec.h>

typedef struct {
    Lexer* lexer;
    cmap_str types;
} Compiler;

bool next(Compiler* compiler, Token* token);

#endif
