#ifndef LEXER_H
#define LEXER_H

#include "token.h"
#include <regex.h>
#include <stdbool.h>

typedef struct {
    regex_t regex;
    int token_type;
} TokenRule;

typedef struct {
    int offset;
    const char* text;
    const TokenRule* rules;
    size_t num_rules;
} Lexer;

Lexer lexer_create(const TokenRule* rules, size_t num_rules);
void lexer_feed(Lexer* lexer, const char* text);
bool lexer_next(Lexer* lexer, Token* token);

#endif
