#ifndef PARSER_H
#define PARSER_H

#include "compiler.h"
#include "node.h"
#include "token.h"

Node parse_token(Compiler* self, Token token);
Nodes parse_until(Compiler* self, TokenType end_token);
Node parse_type(Compiler* self, const char* type);
Node parse_identifier(Compiler* self, const char* name);
Node parse_number(Compiler* self, const char* value);
Node parse_type_ident_pair(Compiler* self, const char* type, const char* name);
Node parse_arg_decl(Compiler* self, const char* type, const char* name);
Node parse_function(Compiler* self, const char* type, const char* name);
Node parse_function_decl(Compiler* self, const char* type, const char* name, Nodes args);
Node parse_function_impl(Compiler* self, const char* type, const char* name, Nodes args);
Node parse_function_call(Compiler* self, const char* name);
void parse_semicolon(Compiler* self);

#endif
